/* ----------------------------------------------------------------------------------------------------------------------
* © Copyright 2018 Visa. All Rights Reserved.
*
* NOTICE: The software and accompanying information and documentation (together, the “Software”) remain the property of
* and are proprietary to Visa and its suppliers and affiliates. The Software remains protected by intellectual property
* rights and may be covered by U.S. and foreign patents or patent applications. The Software is licensed and not sold.
*
* By accessing the Software you are agreeing to Visa's terms of use (developer.visa.com/terms) and privacy policy
* (developer.visa.com/privacy). In addition, all permissible uses of the Software must be in support of Visa products,
* programs and services provided through the Visa Developer Program (VDP) platform only (developer.visa.com).
* THE SOFTWARE AND ANY ASSOCIATED INFORMATION OR DOCUMENTATION IS PROVIDED ON AN “AS IS,” “AS AVAILABLE,” “WITH ALL
* FAULTS” BASIS WITHOUT WARRANTY OR CONDITION OF ANY KIND. YOUR USE IS AT YOUR OWN RISK.
---------------------------------------------------------------------------------------------------------------------- */

/*
 * Foreign Exchange Rates API
 * The Foreign Exchange Rates API provides an easy access to the Visa daily currency conversion rate for a given currency pair.  This is an indicative rate which is dependent on the currency pair as well as the amount, and may be different from the actual rate for settlement of transaction.
 *
 * OpenAPI spec version: v1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.visa.developer.sample.foreign_exchange_rates_api.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * ForeignexchangelookuppostResponse
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.java.JavaClientCodegen", date = "2018-10-16T18:07:39.769+05:30[Asia/Kolkata]")
public class ForeignexchangelookuppostResponse {

  
  @JsonSerialize(include = JsonSerialize.Inclusion.NON_NULL)
  @JsonProperty("conversionRate")
  private Double conversionRate = null;
  
  
  @JsonSerialize(include = JsonSerialize.Inclusion.NON_NULL)
  @JsonProperty("originalDestnAmtBeforeMarkUp")
  private String originalDestnAmtBeforeMarkUp = null;
  
  
  @JsonSerialize(include = JsonSerialize.Inclusion.NON_NULL)
  @JsonProperty("markUpRateApplied")
  private String markUpRateApplied = null;
  
  
  @JsonSerialize(include = JsonSerialize.Inclusion.NON_NULL)
  @JsonProperty("destinationAmount")
  private String destinationAmount = null;
  
  public ForeignexchangelookuppostResponse conversionRate(Double conversionRate) {
    this.conversionRate = conversionRate;
    return this;
  }

  
  /**
  * The Visa daily conversion rate value based on sender&#x27;s currency and recipient&#x27;s currency.
  * @return conversionRate
  **/
  @ApiModelProperty(required = true, value = "The Visa daily conversion rate value based on sender's currency and recipient's currency.")
  public Double getConversionRate() {
    return conversionRate;
  }
  public void setConversionRate(Double conversionRate) {
    this.conversionRate = conversionRate;
  }
  
  public ForeignexchangelookuppostResponse originalDestnAmtBeforeMarkUp(String originalDestnAmtBeforeMarkUp) {
    this.originalDestnAmtBeforeMarkUp = originalDestnAmtBeforeMarkUp;
    return this;
  }

  
  /**
  * The amount denominated in the destination currency without mark up rate applied.
  * @return originalDestnAmtBeforeMarkUp
  **/
  @ApiModelProperty(value = "The amount denominated in the destination currency without mark up rate applied.")
  public String getOriginalDestnAmtBeforeMarkUp() {
    return originalDestnAmtBeforeMarkUp;
  }
  public void setOriginalDestnAmtBeforeMarkUp(String originalDestnAmtBeforeMarkUp) {
    this.originalDestnAmtBeforeMarkUp = originalDestnAmtBeforeMarkUp;
  }
  
  public ForeignexchangelookuppostResponse markUpRateApplied(String markUpRateApplied) {
    this.markUpRateApplied = markUpRateApplied;
    return this;
  }

  
  /**
  * The FX mark up rate that was applied. Example: A value of 0.07 will have 0.07% FX markup rate applied.
  * @return markUpRateApplied
  **/
  @ApiModelProperty(value = "The FX mark up rate that was applied. Example: A value of 0.07 will have 0.07% FX markup rate applied.")
  public String getMarkUpRateApplied() {
    return markUpRateApplied;
  }
  public void setMarkUpRateApplied(String markUpRateApplied) {
    this.markUpRateApplied = markUpRateApplied;
  }
  
  public ForeignexchangelookuppostResponse destinationAmount(String destinationAmount) {
    this.destinationAmount = destinationAmount;
    return this;
  }

  
  /**
  * The transaction amount denominated in the recipient&#x27;s currency.
  * @return destinationAmount
  **/
  @ApiModelProperty(required = true, value = "The transaction amount denominated in the recipient's currency.")
  public String getDestinationAmount() {
    return destinationAmount;
  }
  public void setDestinationAmount(String destinationAmount) {
    this.destinationAmount = destinationAmount;
  }
  
  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ForeignexchangelookuppostResponse foreignexchangelookuppostResponse = (ForeignexchangelookuppostResponse) o;
    return Objects.equals(this.conversionRate, foreignexchangelookuppostResponse.conversionRate) &&
        Objects.equals(this.originalDestnAmtBeforeMarkUp, foreignexchangelookuppostResponse.originalDestnAmtBeforeMarkUp) &&
        Objects.equals(this.markUpRateApplied, foreignexchangelookuppostResponse.markUpRateApplied) &&
        Objects.equals(this.destinationAmount, foreignexchangelookuppostResponse.destinationAmount);
  }

  @Override
  public int hashCode() {
    return Objects.hash(conversionRate, originalDestnAmtBeforeMarkUp, markUpRateApplied, destinationAmount);
  }
  
  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ForeignexchangelookuppostResponse {\n");
    
    sb.append("    conversionRate: ").append(toIndentedString(conversionRate)).append("\n");
    sb.append("    originalDestnAmtBeforeMarkUp: ").append(toIndentedString(originalDestnAmtBeforeMarkUp)).append("\n");
    sb.append("    markUpRateApplied: ").append(toIndentedString(markUpRateApplied)).append("\n");
    sb.append("    destinationAmount: ").append(toIndentedString(destinationAmount)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

  
}



